/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   case_item.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_CASE_ITEM_H
#define UHDM_CASE_ITEM_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class case_item : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: case_item();
    virtual ~case_item() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    virtual int VpiLineNo() const final { return vpiLineNo_; }

    virtual bool VpiLineNo(int data) final { vpiLineNo_ = data; return true;}

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    case_item* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener) const override;

    VectorOfany* VpiExprs() const { return vpiExprs_; }

    bool VpiExprs(VectorOfany* data) {if (!pattern_expr_groupGroupCompliant(data)) return false; vpiExprs_ = data; return true;}

    const any* Stmt() const { return stmt_; }

    bool Stmt(any* data) {if (!stmtGroupCompliant(data)) return false; stmt_ = data; return true;}

    unsigned int VpiType() const final { return vpiCaseItem; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmcase_item; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    int vpiLineNo_ = 0;

    unsigned int uhdmId_ = 0;

    VectorOfany* vpiExprs_ = nullptr;

    any* stmt_ = nullptr;

  };

  
  class case_itemFactory {
  friend Serializer;
  public:
  case_item* Make() {
    case_item* obj = new case_item();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<case_item*> objects_;
  };
  
  
  class VectorOfcase_itemFactory {
  friend Serializer;
  public:
  std::vector<case_item*>* Make() {
    std::vector<case_item*>* obj = new std::vector<case_item*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<case_item*>*> objects_;
  };

};

#endif
