/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   function.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_FUNCTION_H
#define UHDM_FUNCTION_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class function : public task_func {
  public:
    // Implicit constructor used to initialize all members,
    // comment: function();
    virtual ~function() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    virtual int VpiLineNo() const final { return vpiLineNo_; }

    virtual bool VpiLineNo(int data) final { vpiLineNo_ = data; return true;}

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    function* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener) const override;

    bool VpiSigned() const { return vpiSigned_; }

    bool VpiSigned(bool data) { vpiSigned_ = data; return true;}

    int VpiSize() const { return vpiSize_; }

    bool VpiSize(int data) { vpiSize_ = data; return true;}

    int VpiFuncType() const { return vpiFuncType_; }

    bool VpiFuncType(int data) { vpiFuncType_ = data; return true;}

    unsigned int VpiType() const final { return vpiFunction; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmfunction; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    int vpiLineNo_ = 0;

    unsigned int uhdmId_ = 0;

    bool vpiSigned_ = 0;

    int vpiSize_ = 0;

    int vpiFuncType_ = 0;

  };

  
  class functionFactory {
  friend Serializer;
  public:
  function* Make() {
    function* obj = new function();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<function*> objects_;
  };
  
  
  class VectorOffunctionFactory {
  friend Serializer;
  public:
  std::vector<function*>* Make() {
    std::vector<function*>* obj = new std::vector<function*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<function*>*> objects_;
  };

};

#endif
